<?php
/*********************************************
  CPG Dragonfly™ CMS
  ********************************************
  Copyright © 2004 - 2005 by CPG-Nuke Dev Team
  http://www.dragonflycms.com

  Dragonfly is released under the terms and conditions
  of the GNU GPL version 2 or any later version

  $Id:$
**********************************************/
if (!defined('ADMIN_MOD_INSTALL')) { exit; }

class item_stats
{
	var $version;
	var $radmin;
	var $modname;
	var $description;
	var $author;
	var $website;
	var $dbtables;
	var $prefix;

// class constructor
	function item_stats()
	{
		$this->radmin = true;
		$this->version = '1.5.5.1100';
		$this->modname = 'ItemStats';
		$this->description = 'Make links to World of Warcraft items on your site';
		$this->author = 'Yahourt, Thorkal. Ported to DF by Zanix';
		$this->website = 'itemstats.free.fr';
		$this->base = basename(dirname(__FILE__));
		$this->prefix = strtolower($this->base) . '_';
		$this->dbtables = array($this->prefix . 'cache');
	}

// module installer
	function install()
	{
		global $installer;

		$installer->add_query('INSERT', 'config_custom', '"item_stats", "item_lang_default", "en"');
		$installer->add_query('INSERT', 'config_custom', '"item_stats", "path_cache", "xml_cache"');
		$installer->add_query('INSERT', 'config_custom', '"item_stats", "displayitemstatslink", "1"');
		$installer->add_query('INSERT', 'config_custom', '"item_stats", "automatic_search", "1"');
		$installer->add_query('INSERT', 'config_custom', '"item_stats", "integration_mode", "normal"');
		$installer->add_query('INSERT', 'config_custom', '"item_stats", "debug_mode", "0"');
		$installer->add_query('INSERT', 'config_custom', '"item_stats", "icon_store_location", "http://www.wowhead.com/images/icons/medium/"');
		$installer->add_query('INSERT', 'config_custom', '"item_stats", "icon_extension", ".jpg"');
		$installer->add_query('INSERT', 'config_custom', '"item_stats", "path_sockets_image", "http://wow.allakhazam.com/images/"');
		$installer->add_query('INSERT', 'config_custom', '"item_stats", "number_per_update", "35"');
		$installer->add_query('INSERT', 'config_custom', '"item_stats", "download_wowhead_icons", "false"');
		

		$installer->add_query('CREATE', $this->prefix.'cache', "
			`item_name` varchar(100) NOT NULL default '',
			`item_id` varchar(100) default '0',
			`item_lang` varchar(2) default '',
			`item_link` varchar(100) default NULL,
			`item_color` varchar(20) NOT NULL default '',
			`item_icon` varchar(50) NOT NULL default '',
			`item_html` text NOT NULL,
			UNIQUE KEY `item_name` (`item_name`),
			FULLTEXT KEY `item_html` (`item_html`)", $this->prefix . 'cache');

		return true;
	}

	// module uninstaller
	function uninstall()
	{
		global $installer;

		foreach($this->dbtables as $table)
		{
			$installer->add_query('DROP', $table);
		}

		$installer->add_query('DELETE', 'config_custom', 'cfg_name = "item_stats"');

		return true;
	}

	// module upgrader
	function upgrade($prev_version)
	{
		global $installer;

		if( version_compare($prev_version,'1.5.5.1000', '=') )
		{
			$installer->add_query('INSERT', 'config_custom', '"item_stats", "number_per_update", "35"');
			$installer->add_query('INSERT', 'config_custom', '"item_stats", "download_wowhead_icons", "false"');
		}
		
		elseif( version_compare($prev_version,'1.5.5.1000', '<') )
		{
			$installer->add_query('INSERT', 'config_custom', '"item_stats", "item_lang_default", "en"');
			$installer->add_query('INSERT', 'config_custom', '"item_stats", "path_cache", "xml_cache"');
			$installer->add_query('INSERT', 'config_custom', '"item_stats", "displayitemstatslink", "1"');
			$installer->add_query('INSERT', 'config_custom', '"item_stats", "automatic_search", "1"');
			$installer->add_query('INSERT', 'config_custom', '"item_stats", "integration_mode", "normal"');
			$installer->add_query('INSERT', 'config_custom', '"item_stats", "debug_mode", "0"');
			$installer->add_query('INSERT', 'config_custom', '"item_stats", "icon_store_location", "http://www.wowhead.com/images/icons/medium/"');
			$installer->add_query('INSERT', 'config_custom', '"item_stats", "icon_extension", ".jpg"');
			$installer->add_query('INSERT', 'config_custom', '"item_stats", "path_sockets_image", "http://wow.allakhazam.com/images/"');
			$installer->add_query('INSERT', 'config_custom', '"item_stats", "number_per_update", "35"');
			$installer->add_query('INSERT', 'config_custom', '"item_stats", "download_wowhead_icons", "false"');
		}
		return true;
	}
}
